;******************************************************************************
;                                               
; ,    Microchip Technology                                                                   
;Incorporated ( "")    ,  
; ,      Microchip
;    ()    
;    .
;        
;   
;                                                                    
;THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,  
;WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED  
;TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A       
;PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,  
;IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR         
;CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.       
; *******************************************************************
; PICkit 2  2 - "Blink"
;
;   ,   
;  ,    .   
;      ,   
;     
;
; *******************************************************************
; *    See 44-pin Demo Board User's Guide for Lesson Information    *
; *******************************************************************

;************************************************************************************************************
;		 #include <include_file>
;  MPASM,    
;	<include_file> -     .  
;					       
;					 .
;     ,    
; .   255    5     
;************************************************************************************************************

#include <p16F887.inc>

;************************************************************************************************************
;		 __config addr, expr
;  MPASM,    .
; ,    ,      
; ,  ,    Configure>Select Device,  
;    MPLAB.     
;     PIC1X.
;       p16F887.inc    :
;	_CONFIG1                EQU  H'2007'  BIN'00100000-00000111'				
;	_LVP_OFF		EQU  H'2FFF'  BIN'00101111-11111111'
;	_FCMEN_OFF              EQU  H'37FF'  BIN'00110111-11111111'
;	_IESO_OFF               EQU  H'3BFF'  BIN'00111011-11111111'
;	_BOR_OFF                EQU  H'3CFF'  BIN'00111100-11111111'
;	_CPD_OFF                EQU  H'3FFF'  BIN'00111111-11111111'
;	_CP_OFF                 EQU  H'3FFF'  BIN'00111111-11111111'
;	_MCLRE_OFF              EQU  H'3FDF'  BIN'00111111-11011111'
;	_PWRTE_ON               EQU  H'3FEF'  BIN'00111111-11101111'
;	_WDT_OFF                EQU  H'3FF7'  BIN'00111111-11110111'
;	_INTRC_OSC_NOCLKOUT     EQU  H'3FFC'  BIN'00111111-11111100'
;	_CONFIG2                EQU  H'2008'  BIN'00100000-00001000'
;	_WRT_OFF                EQU  H'3FFF'  BIN'00111111-11111111'    ; No prog memmory write protection
;	_BOR21V			EQU  H'3EFF'  BIN'00111110-11111111'
;************************************************************************************************************

	__CONFIG    _CONFIG1, _LVP_OFF & _FCMEN_OFF & _IESO_OFF & _BOR_OFF & _CPD_OFF & _CP_OFF & _MCLRE_OFF & _PWRTE_ON & _WDT_OFF & _INTRC_OSC_NOCLKOUT
	__CONFIG    _CONFIG2, _WRT_OFF & _BOR21V

;************************************************************************************************************
;  :
; 		cblock [<expr>]
;			<label>[:<increment>][,<label>[:<increment>]]
;		endc
;    .   CBLOCK   ,    
;   .    <label>   ,   
;    .      ENDC.  
;     
; 	<expr> -     .    ,   
;		   CBLOCK.   CBLOCK     <expr>, 
;		     .
;	<increment> -     .
;************************************************************************************************************

     cblock 0x20
Delay1               ; Define two file registers for the
Delay2               ; delay loop
     endc

;************************************************************************************************************
; 		[<label>] org <expr>
;     .
;	<expr> -   . 
;    <label>,      <expr>.      
;  ORG,  ,      .   
; PIC18CXX    <expr>.  ORG      
;  .
;************************************************************************************************************
     org 0

;************************************************************************************************************
;    .  PIC16F887.INC
; F        EQU     H'0001'
; STATUS   EQU     H'0003'   BIN'00000011'
; RP0      EQU     H'0005'   BIN'00000101'
; TRISD    EQU     H'0088'   BIN'10001000'
; PORTD    EQU     H'0008'   BIN'00001000'
; 
;************************************************************************************************************

Start:
     bsf       STATUS,RP0     ;  1-      (BSF    BIN'00000011', H'0005')
		;--------------------------------------------------------------------------------------------
		;  BSF      STATUS  ,   
		;   5  6     . ..    
		;  00 (    ).        
		;  01     1.      
		;   D.
		;--------------------------------------------------------------------------------------------
     bcf       TRISD,1        ;   RD0  
		;--------------------------------------------------------------------------------------------
		; ,  BCF H'0088',1      TRISD,  88h 
		;   ,   DS41291F  TRISD1    
		;  39  .
		;--------------------------------------------------------------------------------------------
     bcf       STATUS,RP0     ;  0-  
		;--------------------------------------------------------------------------------------------
		;     ,   STATUS     ,    
		;    ,   ,      
		;           
		; . ,        5   STATUS   .
		;--------------------------------------------------------------------------------------------
MainLoop:
     bsf       PORTD,1        ; turn on LED RD1 (    RD1)
		;--------------------------------------------------------------------------------------------
		;       1   08h   .  
		;      D.       ,
		;        08h        
		;    ,      ,    
		;            .
		;  ,        ,    
		;    . !!!
		;  :         - 
		;    
		;--------------------------------------------------------------------------------------------
OndelayLoop:
     decfsz    Delay1,f       ; Waste time. ( )
		;--------------------------------------------------------------------------------------------
		;      ,     
		;    .       <Delay1>    
		; .   ,     (    <goto OndelayLoop>)
		;   <NOP> ( )        
		;   <Delay1>        00h,    
		;   FFh,     ,       
		; <OndelayLoop>            01h.    
		; ,       .     
		; <goto OndelayLoop>   <NOP>      <decfsz  Delay2,f>
		;--------------------------------------------------------------------------------------------
     goto      OndelayLoop    ; The Inner loop takes 3 instructions per loop * 256 loopss = 768 instructions
		;--------------------------------------------------------------------------------------------
		;       <OndelayLoop>
		;--------------------------------------------------------------------------------------------
     decfsz    Delay2,f       ; The outer loop takes and additional 3 instructions per lap * 256 loops
		;--------------------------------------------------------------------------------------------
		;             
		;        256 
		;--------------------------------------------------------------------------------------------
     goto      OndelayLoop    ; (768+3) * 256 = 197376 instructions / 1M instructions per second = 0.197 sec.
                              ; call it two-tenths of a second.
		;--------------------------------------------------------------------------------------------
		;       <OndelayLoop>
		;--------------------------------------------------------------------------------------------
     bcf       PORTD,1        ; Turn off LED RD1
		;--------------------------------------------------------------------------------------------
		;       88h.      39 
		;--------------------------------------------------------------------------------------------
OffDelayLoop:
     decfsz    Delay1,f       ; same delay as above
     goto      OffDelayLoop
     decfsz    Delay2,f
     goto      OffDelayLoop
		;--------------------------------------------------------------------------------------------
		;       ,    ,    
		;  -      ,  .
		;--------------------------------------------------------------------------------------------
     goto      MainLoop       ; Do it again...
		;--------------------------------------------------------------------------------------------
		;      ,   ,  
		;   .
		;--------------------------------------------------------------------------------------------
     end
     
;************************************************************************************************************
; BSF <f>,<b> -   1  <b>  <f>
; BF <f>,<b> -   0  <b>  <f>
; DECFSZ <f>,<d> -    <f>   ( 1  <f>  )
; 	 <d>=0,     W.
;	 <d>=1,     <f>
;		    0,    
;		   0,      (  
;		"" NOP),     2  
;************************************************************************************************************

;	 DECFSZ -  f,  ,  0
;	: 	DECFSZ f, b
;	: 	0 < f < 127, d  [0, 1]
;	: 	(f) -- 1 --> (dest); ,  (dest) = 0
;	 : 	 
;	: 	00 1011 dfff ffff
;	: 	 f   1.  d = 0,     W.  d = 1,       f.     0,   .    0,  ,     , ,        NOP,       .
;	: 	1 (2)
;	: 

;	HERE   DECFSZ     CNT,1
;	       GOTO       LOOP
;	CONTINUE
;	.            
;	.

;		  :
;		  : 	PC =  HERE
;		CNT = CNT - 1
;		 CNT = 0, PC =  CONTINUE
;		 CNT  0, PC =  HERE + 1